//
//  Cross Track for Java
//  (c)1997 May 17 Programmed by Bv.
//

import java.lang.*;
import java.awt.*;
import java.io.*;

public class Stage extends Thread
  {
  public Blocks blocks;
  public Screen screen;
  
  public Stage(Blocks blocks, Screen screen)
    {
    this.blocks = blocks;
    this.screen = screen;
    }
  
  public void run()
    {
    while(true)
      {
      try{ sleep(5); }catch(InterruptedException e){}
      if(blocks.move()) break;
      int xi = blocks.    Y()/16;
      int xj = blocks.edgeX()/16;
      int yi = blocks.edgeY()/16;
      int yj = blocks.    X()/16;
      int xb = blocks.block(xj,xi);
      int yb = blocks.block(yj,yi);
      if(xb != Blocks.SPACE) blocks.reflectX();
      if(yb != Blocks.SPACE) blocks.reflectY();
      if(xb == Blocks.BLOCK)
        if(blocks.destroy(xj,xi)) break;
      if(yb == Blocks.BLOCK)
        if(blocks.destroy(yj,yi)) break;
      screen.drawAll();
      }
    }
  }